<?php

/* PHP SDK
 * @version 2.0.0
 * @author magicsky0@163.com
 * @copyright © 2014, Ctrip Corporation. All rights reserved.
 */

class OTA_FlightSearch
{
	public $open_api = '/Flight/DomesticFlight/OTA_FlightSearch.asmx';
	public $startcity = ''; 	// 出发城市
	public $endcity = ''; 			// 到达城市
	public $times= ''; 		// 出发时间

	
	public function __construct( $open_api, $args )
	{
		

		$this->open_api = $open_api.$this->open_api; // TODO:检测open api，如果不合法则覆盖重写
		if( array_key_exists('startcity',$args) && $args['startcity'])
		{
			$this->startcity = $this->getcitycode($args['startcity']);
		}		
		if( array_key_exists('endcity',$args) && $args['endcity'])
		{
			$this->endcity = $this->getcitycode($args['endcity']);
		}
		if( array_key_exists('times',$args) && $args['times'])
		{
			$this->times = $args['times'];
		}
	}
	/**
	 * 获取城市三字码
	 * @param stirng $cityname
	 */
	public function getcitycode($cityname){
	$xml=simplexml_load_file("api/xml/ticket_city.xml");
    $city_name=$cityname;  //取参数
    $citycode="";  //机场的三字码，即最后的答案
	 foreach($xml->CityInfoEntity as $CityInfoEntity)
    {
       if($city_name==$CityInfoEntity->CityName)
        {
         $citycode=$CityInfoEntity->CityCode;
	    }  
    }
    return $citycode;
	}
	/**
	 * 构造请求xml字符串
	 * @param int $uid
	 * @param int $sid
	 * @param string $stmp
	 * @param string $sign
	 * @param stirng $type
	 */
	public function request_xml( $uid, $sid, $stmp, $sign, $type )
	{
		$request_xml = 
			'<?xml version="1.0" encoding="utf-8"?>'
			.'<Request>'
			.'<Header AllianceID="66608" SID="508495" TimeStamp="1423062460" RequestType="OTA_FlightSearch" Signature="80F56360EB3DA96CBE827F4E7A06BB9F" />'
			.'<FlightSearchRequest>'
			.'<SearchType>S</SearchType>'
			.'<Routes>'
			.'<FlightRoute>'
			.'<DepartCity>'.$this->startcity.'</DepartCity>'
			.'<ArriveCity>'.$this->endcity.'</ArriveCity>'
			.'<DepartDate>'.$this->times.'</DepartDate>'
			.'<AirlineDibitCode></AirlineDibitCode>'
            .'<DepartPort></DepartPort>'
			.'<ArrivePort></ArrivePort>'
			.'<EarliestDepartTime>0001-01-01T00:00:00</EarliestDepartTime>'
			.'<LatestDepartTime>0001-01-01T00:00:00</LatestDepartTime>'
			.'</FlightRoute>'
			.'</Routes>'
			.'<SendTicketCity>SHA</SendTicketCity>'
			.'<IsSimpleResponse>false</IsSimpleResponse>'
			.'<IsLowestPrice>false</IsLowestPrice>'
			.'<PriceTypeOptions>'
			.'<string>NormalPrice</string>'
			.'</PriceTypeOptions>'
			.'<ProductTypeOptions></ProductTypeOptions>'
			.'<OrderBy>DepartTime</OrderBy>'
			.'<Direction>ASC</Direction>'
			.'</FlightSearchRequest>'
			.'</Request>';
		
		
		
		// 需要将此处的xml嵌入到外层xml中，故需要将其转义
		$request_xml = str_replace("<",@"&lt;",$request_xml);
		$request_xml = str_replace(">",@"&gt;",$request_xml);
		
		return $request_xml;
	}
	
	public function respond_xml( $string )
	{
		// 将内层xmll中转义的符号恢复
		$string = str_replace("&lt;","<",$string);
		$string = str_replace("&gt;",">",$string);
		return simplexml_load_string($string);	
	}
}
